<template>
  <PageWrapper dense fixedHeight contentFullHeight contentClass="flex">
    <BasicTable
      @register="registerTable"
      :row-selection="{ selectedRowKeys: selectedKeys, onChange: onSelectChange }"
    >
      <template #toolbar>
        <template v-for="button in tableButtonConfig" :key="button.code">
          <a-button v-if="button.isDefault" type="primary" @click="buttonClick(button.code)">
            <template #icon><Icon :icon="button.icon" /></template>
            {{ button.name }}
          </a-button>
          <a-button v-else type="primary">
            <template #icon><Icon :icon="button.icon" /></template>
            {{ button.name }}
          </a-button>
        </template>
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.dataIndex === 'action'">
          <TableAction :actions="getActions(record)" />
        </template>
        <template v-if="column.dataIndex === 'priority'">
          <div
            style="
              color: #ffffff;
              background: #ffaf5e;
              border-radius: 20px 20px 20px 20px;
              opacity: 1;
              width: fit-content;
              padding: 0 10px;
            "
            :style="{
              background:
                record.priority == '非常紧急'
                  ? '#FF5353'
                  : record.priority == '紧急'
                  ? '#FFAF5E'
                  : '#999999',
            }"
            >{{ record.priority }}</div
          >
        </template>
      </template>
    </BasicTable>

    <PrintPreview
      v-if="printData.visible"
      :id="printData.id"
      :request-params-configs="printData.requestParamsConfigs"
      :request-body-configs="printData.requestBodyConfigs"
      :request-header-configs="printData.requestHeaderConfigs"
      @close="printData.visible = false"
    />
    <ProOrderModal @register="registerModal" @success="handleSuccess" />
    <!-- 自己写的查看和编辑弹窗 -->
    <a-modal
      :maskClosable="false"
      :title="titleModa"
      v-model:visible="visibleModa0"
      :confirm-loading="confirmLoading"
      :width="1000"
      :footer="null"
    >
      <propsModal0
        v-if="visibleModa0"
        :rowData="rowData0"
        @cancel="handleCancel"
        @success="handleSuccess"
      ></propsModal0>
    </a-modal>
    <a-modal
      :maskClosable="false"
      :title="titleModa"
      v-model:visible="visibleModa"
      :confirm-loading="confirmLoading"
      :width="1000"
      :footer="null"
    >
      <propsModal
        v-if="visibleModa"
        :rowData="rowData"
        @cancel="handleCancel"
        @success="handleSuccess"
      ></propsModal>
    </a-modal>
    <a-modal
      :maskClosable="false"
      title="作废"
      v-model:visible="visibleModaCancel"
      :confirm-loading="confirmLoading"
      :width="500"
      :footer="null"
    >
      <div style="height: 300px; padding-top: 20px; padding-right: 20px">
        <div>
          <a-form ref="formRef" :model="cancelData" :labelCol="{ span: 6 }">
            <a-col :span="24">
              <a-form-item label="作废理由" name="cancelRemark" required>
                <a-textarea
                  maxlength="200"
                  :disabled="cancelState && cancelState.length > 0"
                  v-model:value="cancelData.cancelRemark"
                  :auto-size="{ minRows: 2, maxRows: 5 }"
                />
              </a-form-item>
            </a-col>
          </a-form>
        </div>
        <div
          style="
            padding: 10px 16px;
            text-align: right;
            background: white;
            border-top: 1px solid rgb(240, 240, 240);
            border-radius: 0px 0px 2px 2px;
            position: absolute;
            bottom: 1px;
            width: 98%;
          "
          v-if="!cancelState"
        >
          <a-button @click="handleCancelRecordClose">取消</a-button>
          <a-button @click="handleCancelRecordSubmit" type="primary" style="margin-left: 12px"
            >确认</a-button
          >
        </div>
      </div>
    </a-modal>
  </PageWrapper>
</template>
<script lang="ts" setup>
  import { ref, computed, createVNode, reactive } from 'vue';

  import { Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import { BasicTable, useTable, TableAction, ActionItem } from '/@/components/Table';
  import { getMesProOrderPage, deleteMesProOrder, cancelMesProOrder } from '/@/api/mes/proorder';
  import { PageWrapper } from '/@/components/Page';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { usePermission } from '/@/hooks/web/usePermission';
  import { useRouter } from 'vue-router';

  import { getPrintConfigInfo } from '/@/api/system/generator/print';
  import PrintPreview from '/@/views/generator/print/Preview.vue';
  import { getMesProOrder } from '/@/api/mes/proorder';
  import { PrintButton } from '/@/enums/printEnum';
  import { InputParamItem } from '/@/components/ApiConfig/src/interface';

  import { useModal } from '/@/components/Modal';

  import ProOrderModal from './components/ProOrderModal.vue';
  import propsModal from '../proorderplan/components/propsModal.vue';
  import propsModal0 from '../proorder/components/propsModal.vue';
  import { searchFormSchema, columns } from './components/config';
  import Icon from '/@/components/Icon/index';

  const { notification } = useMessage();
  const { t } = useI18n();
  defineEmits(['register']);
  const { filterColumnAuth, filterButtonAuth } = usePermission();

  const filterColumns = filterColumnAuth(columns, false);
  //展示在列表内的按钮
  const actionButtons = ref<string[]>(['view', 'edit', 'delete', 'startwork', 'addPlan', 'cancel']);
  const buttonConfigs = computed(() => {
    const list = [
      // { isUse: true, name: '查看', code: 'view', icon: 'ant-design:eye-outlined', isDefault: true },
      { isUse: true, name: '新增', code: 'add', icon: 'ant-design:plus-outlined', isDefault: true },

      {
        isUse: true,
        name: '编辑',
        code: 'edit',
        icon: 'ant-design:form-outlined',
        isDefault: true,
      },
      {
        isUse: true,
        name: '删除',
        code: 'delete',
        icon: 'ant-design:delete-outlined',
        isDefault: true,
      },
      {
        isUse: true,
        name: '作废',
        code: 'cancel',
        icon: 'ant-design:delete-outlined',
        isDefault: true,
      },
      {
        isUse: true,
        name: '创建生产计划',
        code: 'addPlan',
        icon: 'ant-design:plus-outlined',
        isDefault: true,
      },
    ];
    return filterButtonAuth(list);
  });

  const tableButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => !actionButtons.value.includes(x.code));
  });

  const actionButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => actionButtons.value.includes(x.code));
  });

  const btnEvent = {
    view: handleView,
    add: handleAdd,
    edit: handleEdit,
    delete: handleDelete,
    cancel: handleCancelRecord,
    addPlan: handleAddPlan,
  };

  const { currentRoute } = useRouter();
  const printMenuId = computed(() => currentRoute.value.meta.menuId as string);
  const formIdComputedRef = computed(() => currentRoute.value.meta.formId as string);

  const selectedKeys = ref<string[]>([]);
  const selectedRowsData = ref<any[]>([]);

  const [registerModal, { openModal }] = useModal();

  // 模板打印 入参参数
  let printData: {
    visible: boolean;
    id: string;
    code: string;
    requestParamsConfigs: Array<InputParamItem>;
    requestHeaderConfigs: Array<InputParamItem>;
    requestBodyConfigs: Array<InputParamItem>;
  } = reactive({
    visible: false,
    id: '',
    code: '',
    requestParamsConfigs: [],
    requestHeaderConfigs: [],
    requestBodyConfigs: [],
  });

  const [registerTable, { reload }] = useTable({
    title: '生产订单',
    api: getMesProOrderPage,
    rowKey: 'id',
    columns: filterColumns,
    formConfig: {
      rowProps: {
        gutter: 16,
      },
      schemas: searchFormSchema,
      fieldMapToTime: [['onlineDate', ['onlineDateStart', 'onlineDateEnd'], 'YYYY-MM-DD ', true]],
    },
    beforeFetch: (params) => {
      return { ...params, FormId: formIdComputedRef.value, PK: 'id' };
    },
    useSearchForm: true,
    showTableSetting: false,
    showLine: true,
    striped: false,
    actionColumn: {
      align: 'left',
      width: 220,
      title: '操作',
      dataIndex: 'action',
      slots: { customRender: 'action' },
    },
    customRow,
  });

  function buttonClick(code) {
    if (code.includes(PrintButton.CODE)) {
      printData.code = code;
    }
    btnEvent[code]();
  }

  function handleAdd() {
    // openModal(true, {
    //   isUpdate: false,
    // });
    rowData0.value = {
      id: '',
      isUpdate: true,
    };

    titleModa.value = '新增生产订单';
    visibleModa0.value = true;
  }

  function handleEdit(record: Recordable) {
    // openModal(true, {
    //   id: record.id,
    //   isUpdate: true,
    // });
    rowData0.value = {
      id: record.id,
      isUpdate: true,
    };

    titleModa.value = '编辑生产订单';
    visibleModa0.value = true;
  }
  const titleModa = ref<string>('');
  const visibleModa = ref<boolean>(false);
  const visibleModa0 = ref<boolean>(false);
  const confirmLoading = ref<boolean>(false);
  const rowData = ref({});
  const rowData0 = ref({});
  function handleAddPlan(record: Recordable) {
    rowData.value = {
      id: '',
      orderId: record.id,
      orderNo: record.orderNo,
      isUpdate: true,
    };

    titleModa.value = '创建生产计划';
    visibleModa.value = true;
  }
  async function handleCancel() {
    visibleModa.value = false;
    visibleModa0.value = false;
  }

  const cancelData = ref<any>({
    cancelRemark: '',
    state: '',
    id: '',
  });
  const visibleModaCancel = ref<boolean>(false);

  function handleCancelRecord(record: Recordable) {
    cancelData.value.cancelRemark = '';
    cancelData.value.id = '';
    cancelData.value.state = '';
    cancelData.value.id = record.id;
    if (record.state == '3' || record.state == '已作废') {
      cancelData.value.cancelRemark = record.cancelRemark;
      cancelData.value.state = record.state;
    }
    visibleModaCancel.value = true;
  }
  function handleCancelRecordClose() {
    visibleModaCancel.value = false;
  }
  function handleCancelRecordSubmit() {
    // Modal.confirm({
    //   title: '提示信息',
    //   icon: createVNode(ExclamationCircleOutlined),
    //   content: '是否确认作废？',
    //   okText: '确认',
    //   cancelText: '取消',
    //   onOk() {
    if (!cancelData.value.cancelRemark || cancelData.value.cancelRemark.length == 0) {
      notification.error({
        message: 'Tip',
        description: t('请填写作废理由'),
      });
      return;
    }
    cancelMesProOrder(cancelData.value.id, cancelData.value.cancelRemark).then((_) => {
      handleCancelRecordClose();
      reload();
      notification.success({
        message: 'Tip',
        description: t('作废成功！'),
      });
    });
    //   },
    //   onCancel() {},
    // });
  }
  function handleDelete(record: Recordable) {
    deleteList([record.id]);
  }

  function deleteList(ids) {
    Modal.confirm({
      title: '提示信息',
      icon: createVNode(ExclamationCircleOutlined),
      content: '是否确认删除？',
      okText: '确认',
      cancelText: '取消',
      onOk() {
        deleteMesProOrder(ids).then((_) => {
          reload();
          notification.success({
            message: 'Tip',
            description: t('删除成功！'),
          });
        });
      },
      onCancel() {},
    });
  }

  // 模板打印
  async function handleTemplateprint() {
    if (!selectedKeys.value.length) {
      notification.warning({
        message: t('提示'),
        description: t('请选择数据'),
      });
      return;
    }
    if (selectedKeys.value.length > 1) {
      notification.warning({
        message: t('提示'),
        description: t('只能选择一条数据进行操作'),
      });
      return;
    }
    let id = selectedKeys.value[0];
    try {
      const record = await getMesProOrder(id);
      let res = await getPrintConfigInfo(printData.code, printMenuId.value);
      if (res.enabledMark == null) {
        notification.warning({
          message: t('提示'),
          description: t('当前功能未绑定打印模板，请绑定后再进行模板打印。'),
        });
        return;
      }
      if (res.enabledMark == 0) {
        notification.warning({
          message: t('提示'),
          description: t('找不到打印模板，请联系管理员。'),
        });
        return;
      }
      printData.id = res.schemaId;
      if (res.apiConfig) {
        let json = JSON.parse(res.apiConfig);
        if (json.requestParamsConfigs && json.requestParamsConfigs.length > 0) {
          printData.requestParamsConfigs = json.requestParamsConfigs.map((ele) => {
            if (ele.config && record[ele.config] != undefined) {
              ele.value = record[ele.config];
            }
            return ele;
          });
        }
        if (json.requestHeaderConfigs && json.requestHeaderConfigs.length > 0) {
          printData.requestHeaderConfigs = json.requestHeaderConfigs.map((ele) => {
            if (ele.config && record[ele.config] != undefined) {
              ele.value = record[ele.config];
            }
            return ele;
          });
        }
        if (json.requestBodyConfigs && json.requestBodyConfigs.length > 0) {
          printData.requestBodyConfigs = json.requestBodyConfigs.map((ele) => {
            if (ele.config && record[ele.config] != undefined) {
              ele.value = record[ele.config];
            }
            return ele;
          });
        }
        printData.visible = true;
      } else {
        notification.warning({
          message: t('提示'),
          description: t('当前功能未绑定打印模板，请绑定后再进行模板打印。'),
        });
      }
    } catch (error) {}
  }

  function onSelectChange(selectedRowKeys: [], selectedRows) {
    selectedKeys.value = selectedRowKeys;
    selectedRowsData.value = selectedRows;
  }

  function customRow(record: Recordable) {
    return {
      onClick: () => {
        let selectedRowKeys = [...selectedKeys.value];
        if (selectedRowKeys.indexOf(record.id) >= 0) {
          let index = selectedRowKeys.indexOf(record.id);
          selectedRowKeys.splice(index, 1);
        } else {
          selectedRowKeys.push(record.id);
        }
        selectedKeys.value = selectedRowKeys;
      },
    };
  }

  function handleSuccess() {
    handleCancel();
    reload();
  }

  function handleView(record: Recordable) {
    openModal(true, {
      isView: true,
      id: record.id,
    });
  }

  function getActions(record: Recordable): ActionItem[] {
    const actionsList: ActionItem[] = actionButtonConfig.value?.map((button) => {
      if (!record.workflowData?.processId) {
        return {
          icon: button?.icon,
          tooltip: button?.name,
          color: button.code === 'delete' || button.code === 'cancel' ? 'error' : undefined,
          onClick: btnEvent[button.code].bind(null, record),
        };
      } else {
        if (button.code === 'view') {
          return {
            icon: button?.icon,
            tooltip: button?.name,
            onClick: btnEvent[button.code].bind(null, record),
          };
        } else {
          return {};
        }
      }
    });
    return actionsList.filter((e) => {
      if (e.tooltip == '删除') {
        if (!record.state || record.state == '1' || record.state == '待计划') return true;
        else return false;
      }
      if (e.tooltip == '作废') {
        if (record.state && record.state != '1' && record.state != '待计划') return true;
        else return false;
      }
      if (e.tooltip == '创建生产计划' || e.tooltip == '编辑') {
        if (!record.state || record.state == '1' || record.state == '待计划') return true;
        else return false;
      } else return true;
    });
  }
</script>
<style lang="less" scoped>
  :deep(.ant-table-selection-col) {
    width: 50px;
  }
</style>
